- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Static Public Attributes

# MFnPlugin Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

This reference page is linked to from the following overview topics: Attaching a plug-in to a Maya menu, Implementing a hardware shading node plug-in, Example custom transform, Deformer Node Example, File Translator Examples.

Search for all occurrences

## Detailed Description

Register and deregister plug-in services with Maya.

This class is used in the initializePlugin and uninitializePlugin functions of a Maya plug-in to respectively register and deregister the plug-in's services (commands, node types, etc) with Maya. The constructor for this class must be passed the MObject that Maya provides as an argument to initializePlugin and uninitializePlugin.

MFnPlugin provides various registration methods for use inside initializePlugin, when the plug-in is being loaded, and deregistration methods for use inside uninitializePlugin, when the plug-in is being unloaded. In general it is good practice to have uninitializePlugin deregister the plug-in's services in the reverse order in which they were registered in initializePlugin. This ensures, for example, that a custom datatype is not deregistered before the node types which use it.

A plug-in's uninitializePlugin function is only called when the plug-in is explicitly unloaded. It is not called when Maya exits. Normally this is not a problem because system resources such as memory and open file handles are automatically released by the operating system when Maya exits. However, if there are cleanup tasks which a plug-in must perform even when Maya exits, for example deleting a temporary file, then the plug-in's initializePlugin can use the MSceneMessage::addCallback method with a message of "kMayaExiting" to register a callback function that will be executed when Maya is about to exit. The callback function can then handle any cleanup activities which the operating system won't handle automatically on exit.

A side effect of including MFnPlugin.h in a source file is to embed an API version string into the corresponding compiled object file. Because of this, including MFnPlugin.h in more than one source file in the same plug-in will lead to conflicts when the plug-in is linked. If it is necessary to include MFnPlugin.h in more than one of a plug-in's source files the preprocessor macro MNoVersionString should be defined in all but one of those files prior to the inclusion of MFnPlugin.h. Normally, this issue will not arise as only the file that contains the initializePlugin and uninitializePlugin routines should need to include MFnPlugin.h.

It is unusual, but possible, to instantiate several MFnPlugin objects within a single plug-in binary. In this case the vendor and version information that is set for the plug-in is taken from the first instance as this information works per binary rather than per command/node etc.

Examples:

  affectsNode.cpp, animCubeNode.cpp, animExportUtil.cpp, animImportExport.cpp, animInfoCmd.cpp, anisotropicShader.cpp, apiMeshShape.cpp, apiSimpleShape.cpp, arcLenNode.cpp, AshliPluginMain.cpp, backfillShader.cpp, blindComplexDataCmd.cpp, blindDataPluginMain.cpp, blindDoubleDataCmd.cpp, blindShortDataCmd.cpp, brickShader.cpp, buildRotationNode.cpp, cellShader.cpp, checkerShader.cpp, circleNode.cpp, cleanPerFaceAssignmentPluginMain.cpp, clearcoat.cpp, closestPointCmd.cpp, closestPointOnCurvePlugin.cpp, closestPointOnNurbsSurfaceCmd.cpp, clothPaintAttrCmd.cpp, clusterWeightFunction.cpp, componentScaleManip.cpp, compositingShader.cpp, conditionTest.cpp, contrastShader.cpp, convertBumpCmd.cpp, convertEdgesToFacesCmd.cpp, convertVerticesToEdgesCmd.cpp, convertVerticesToFacesCmd.cpp, createClipCmd.cpp, curvedArrowsNode.cpp, customAttrManip.cpp, customImagePlane.cpp, cvColorNode.cpp, cvColorShader.cpp, cvPosCmd.cpp, D3DViewportRendererPlugin.cpp, dagMessageCmd.cpp, dagPoseInfoCmd.cpp, ddsFloatReader.cpp, deletedMsgCmd.cpp, depthShader.cpp, displacementShader.cpp, dynExprField.cpp, eventTest.cpp, exampleMRampAttribute.cpp, exportJointClusterDataCmd.cpp, exportSkinClusterDataCmd.cpp, fileIOMsgCmd.cpp, filteredAsciiFile.cpp, flameShader.cpp, flipUVMain.cpp, fluidInfoCmd.cpp, footPrintManip.cpp, footPrintNode.cpp, fullLoftNode.cpp, gammaShader.cpp, genericAttributeNode.cpp, geometryCacheConverter.cpp, geometrySurfaceConstraint.cpp, geomShader.cpp, hairCollisionSolver.cpp, helix2Cmd.cpp, helixTool.cpp, hlslPluginMain.cpp, hwAnisotropicShader_NV20.cpp, hwColorPerVertexShader.cpp, hwDecalBumpShader_NV20.cpp, hwManagedTextureShader.cpp, hwPhongShader.cpp, hwReflectBumpShader_NV20.cpp, hwRefractReflectShader_NV20.cpp, hwRenderPostEffect.cpp, hwToonShader_NV20.cpp, hwUnlitShader.cpp, iffInfoCmd.cpp, iffPixelCmd.cpp, iffPpmCmd.cpp, instanceCallbackCmd.cpp, interpShader.cpp, intersectCmd.cpp, intersectOnNurbsSurfaceCmd.cpp, jitterNode.cpp, jlcVcrDevice.cpp, lambertShader.cpp, lassoTool.cpp, latticeNoise.cpp, lavaShader.cpp, lepTranslator.cpp, lightShader.cpp, lineManip.cpp, lineManipContainer.cpp, lockEvent.cpp, marqueeTool.cpp, maTranslator.cpp, meshOpMain.cpp, meshReorderPlugin.cpp, mixtureShader.cpp, motionPathCmd.cpp, motionTraceCmd.cpp, moveCurveCVsCmd.cpp, moveManip.cpp, moveNumericTool.cpp, moveTool.cpp, multiCurveNode.cpp, narrowPolyViewerMain.cpp, nodeCreatedCBCmd.cpp, nodeInfoCmd.cpp, nodeMessageCmd.cpp, noiseShader.cpp, objExport.cpp, offsetNode.cpp, OpenEXR.cpp, OpenGLViewportRendererPlugin.cpp, ownerEmitter.cpp, particleAttrNodeMain.cpp, particlePathsCmd.cpp, particleSystemInfoCmd.cpp, peltOverlapCmd.cpp, pfxInfoCmd.cpp, phongShader.cpp, pickCmd.cpp, pluginMain.cpp, pnTrianglesNode.cpp, pointOnMeshInfoPlugin.cpp, pointOnSubdNode.cpp, polyMessageCmd.cpp, polyPrimitiveCmd.cpp, polyRawExporter.cpp, polyTrgNode.cpp, polyX3DExporter.cpp, progressWindowCmd.cpp, quadricShape.cpp, referenceQueryCmd.cpp, renderAccessNode.cpp, renderViewInteractiveRenderCmd.cpp, renderViewRenderCmd.cpp, renderViewRenderRegionCmd.cpp, rockingTransformCheckMain.cpp, rockingTransformMain.cpp, rotateManip.cpp, sampleCmd.cpp, sampleParticles.cpp, scanDagCmd.cpp, scanDagSyntax.cpp, shadowMatteShader.cpp, shellNode.cpp, shiftNode.cpp, simpleEmitter.cpp, simpleFluidEmitter.cpp, simpleImageFile.cpp, simpleLoftNode.cpp, simpleSolverNode.cpp, simpleSpring.cpp, sineNode.cpp, slopeShader.cpp, solidCheckerShader.cpp, spiralAnimCurveCmd.cpp, splitUVMain.cpp, squareScaleManip.cpp, squareScaleManipContext.cpp, stringFormatNode.cpp, surfaceBumpManip.cpp, surfaceCreateCmd.cpp, surfaceTwistCmd.cpp, sweptEmitter.cpp, swissArmyManip.cpp, testNobjectNode.cpp, testNucleusNode.cpp, tiffFloatReader.cpp, torusField.cpp, transCircleNode.cpp, translateCmd.cpp, undoRedoMsgCmd.cpp, userMsgCmd.cpp, viewCallbackTest.cpp, volumeShader.cpp, weightListNode.cpp, XmlGeometryCache.cpp, yTwistNode.cpp, and zoomCameraCmd.cpp.

`#include <MFnPlugin.h>`

Inheritance diagram for MFnPlugin:
[legend]

List of all members.

## Public Member Functions
| MFnPlugin ()
| Default class constructor.
| MFnPlugin (MObject &object, const char *vendor="Unknown", const char *version="Unknown", const char *requiredApiVersion="Any", MStatus *ReturnStatus=0L)
| Class constructor that initializes the function set to the given MObject.
virtual | ~MFnPlugin ()
| The class destructor.
virtual MFn::Type | type () const
| Return the type of this function set.
MString | vendor (MStatus *ReturnStatus=NULL) const
| Return the vendor string supplied in the MFnPlugin constructor.
MString | version (MStatus *ReturnStatus=NULL) const
| Return the version string supplied in the MFnPlugin constructor.
MString | apiVersion (MStatus *ReturnStatus=NULL) const
| Return the required API version string supplied in the MFnPlugin constructor.
MString | name (MStatus *ReturnStatus=NULL) const
| Return the name by which Maya knows this plug-in.
MString | loadPath (MStatus *ReturnStatus=NULL) const
| Determine the path where the plugin was loaded.
MStatus | setName (const MString &newName, bool allowRename=true)
| Set the name by which Maya knows this plug-in.
MStatus | setVersion (const MString &newVersion)
| Set the version name for this plug-in.
MStatus | registerCommand (const MString &commandName, MCreatorFunction creatorFunction, MCreateSyntaxFunction createSyntaxFunction=NULL)
| Register a new command with Maya.
MStatus | deregisterCommand (const MString &commandName)
| Deregister the user defined command from Maya.
MStatus | registerControlCommand (const MString &commandName, MCreatorFunction creatorFunction)
| Register a new control command with Maya.
MStatus | deregisterControlCommand (const MString &commandName)
| Deregister the user defined control command from Maya.
MStatus | registerModelEditorCommand (const MString &commandName, MCreatorFunction creatorFunction, MCreatorFunction paneCreatorFunction)
| Register a new model editor command with Maya.
MStatus | deregisterModelEditorCommand (const MString &commandName)
| Deregister the user defined editor command from Maya.
MStatus | registerConstraintCommand (const MString &commandName, MCreatorFunction creatorFunction)
| Register a new constraint command with Maya.
MStatus | deregisterConstraintCommand (const MString &commandName)
| Deregister the user defined constraint command from Maya.
MStatus | registerContextCommand (const MString &commandName, MCreatorFunction creatorFunction)
| Register a new context command with Maya.
MStatus | registerContextCommand (const MString &commandName, MCreatorFunction creatorFunction, const MString &toolCmdName, MCreatorFunction toolCmdCreator, MCreateSyntaxFunction toolCmdSyntax=NULL)
| Register a new context command and a new tool command with Maya.
MStatus | deregisterContextCommand (const MString &commandName)
| Deregister the given user defined context command from Maya.
MStatus | deregisterContextCommand (const MString &commandName, const MString &toolCmdName)
| Deregister the given user defined context command and tool command from Maya.
MStatus | registerNode (const MString &typeName, const MTypeId &typeId, MCreatorFunction creatorFunction, MInitializeFunction initFunction, MPxNode::Type type=MPxNode::kDependNode, const MString *classification=NULL)
| Register a new dependency node with Maya.
MStatus | deregisterNode (const MTypeId &typeId)
| Deregister the given user defined dependency node type Maya.
MStatus | registerShape (const MString &typeName, const MTypeId &typeId, MCreatorFunction creatorFunction, MInitializeFunction initFunction, MCreatorFunction uiCreatorFunction, const MString *classification=NULL)
| Registers the given user defined shape node with Maya.
MStatus | registerTransform (const MString &typeName, const MTypeId &typeId, MCreatorFunction creatorFunction, MInitializeFunction initFunction, MCreateXformMatrixFunction xformCreatorFunction, const MTypeId &xformId, const MString *classification=NULL)
| Registers the given user defined transform node with Maya.
MStatus | registerData (const MString &typeName, const MTypeId &typeId, MCreatorFunction creatorFunction, MPxData::Type type=MPxData::kData)
| Register a new data type with Maya.
MStatus | deregisterData (const MTypeId &typeId)
| Deregister the given user defined data type from Maya.
MStatus | registerDevice (const MString &deviceName, MCreatorFunction creatorFunction)
| Register a new input device with Maya.
MStatus | deregisterDevice (const MString &deviceName)
| Deregister the given user defined input device from Maya.
MStatus | registerFileTranslator (const MString &translatorName, char *pixmapName, MCreatorFunction creatorFunction, char *optionsScriptName=NULL, char *defaultOptionsString=NULL, bool requiresFullMel=false, MString dataStorageLocation=MFnPlugin::kDefaultDataLocation)
| Register a new file translator with Maya.
MStatus | deregisterFileTranslator (const MString &translatorName)
| Deregister the specified file translator with Maya.
MStatus | registerIkSolver (const MString &ikSolverName, MCreatorFunction creatorFunction)
| Register a new ik-solver with Maya.
MStatus | deregisterIkSolver (const MString &ikSolverName)
| Deregister the specified ik-solver with Maya.
MStatus | registerCacheFormat (const MString &cacheFormatName, MCreatorFunction creatorFunction)
| Register a new cache format with Maya.
MStatus | deregisterCacheFormat (const MString &cacheFormatName)
| Deregister the specified cache format with Maya.
MStatus | registerUIStrings (MInitializeFunction registerMStringResources, const MString &pluginStringsProc)
| Set the callback and procedure names of routines that register plugin string resources and optionally load localized values for them.
MStatus | registerDragAndDropBehavior (const MString &behaviorName, MCreatorFunction creatorFunction)
| Register a new drag and drop behavior with Maya.
MStatus | deregisterDragAndDropBehavior (const MString &behaviorName)
| Deregister the given drag and drop behavior from Maya.
MStatus | registerImageFile (const MString &imageFormatName, MCreatorFunction creatorFunction, const MStringArray &imageFileExtensions)
| Register a new image file translator with Maya.
MStatus | deregisterImageFile (const MString &imageFormatName)
| Deregister the specified image file translator with Maya.
MStatus | registerRenderPassImpl (const MString &passImplId, MRenderPassDef *passDef, MCreatorFunction creatorFunction, bool overload=false)
| Register a new render pass implementation with Maya and associate with the given render pass definition.
MStatus | deregisterRenderPassImpl (const MString &passImplId)
| Deregister the specified render pass implementation with Maya.
MStatus | registerAttributePatternFactory (const MString &typeName, MCreatorFunction fnPtr)
| Registers a new attribute pattern factory type with Maya.
MStatus | deregisterAttributePatternFactory (const MString &typeName)
| Deregister the attribute pattern factory type with Maya.
MTypeId | matrixTypeIdFromXformId (const MTypeId &xformTypeId, MStatus *ReturnStatus=NULL)
| The function returns the MTypeId of the matrix when the MTypeId of the corresponding xform is given.
MStringArray | addMenuItem (const MString &menuItemName, const MString &parentName, const MString &commandName, const MString &commandParams, bool needOptionBox=false, const MString *optBoxFunction=NULL, MStatus *retStatus=NULL)
| The function adds the menuItem to the specified parent, and associates a command with it.
MStatus | removeMenuItem (MStringArray &menuItemNames)
| The function removes the menuItem and the corresponding option box, if exists, from the UI.
MStatus | registerMaterialInfo (const MString &type, MMaterialInfoFactoryFnPtr fnPtr)
| Registers a new material information type with Maya.
MStatus | unregisterMaterialInfo (const MString &typeName)
| Deregister the specified material info type with Maya.
MStatus | registerBakeEngine (const MString &typeName, MBakeEngineCreatorFnPtr fnPtr)
| Registers a new bake engine type with Maya.
MStatus | unregisterBakeEngine (const MString &typeName)
| Deregister the bake engine type with Maya.
MStatus | registerTransform (const MString &typeName, const MTypeId &typeId, MCreatorFunction creatorFunction, MInitializeFunction initFunction, MCreatorFunction xformCreatorFunction, const MTypeId &xformId, const MString *classification=NULL)
| Obsolete.
MStatus | registerUI (const MString &creationProc, const MString &deletionProc, const MString &creationBatchProc="", const MString &deletionBatchProc="")
| NO SCRIPT SUPPORT.
## Static Public Member Functions
static MObject | findPlugin (const MString &pluginName)
| Returns an MObject corresponding to the named plugin.
static bool | isNodeRegistered (const MString &typeName)
| Queries if the given typeName has been registered by maya or plugins.
static void | setRegisteringCallableScript ()
| Mark this MFnPlugin object as one that will be passed callbacks defined in script. Search for all occurrences
static bool | registeringCallableScript ()
| Return true if this MFnPlugin object has its callbacks defined in script.
static const char * | className ()
| Returns the name of this class.
## Static Public Attributes Search for all occurrences
static const MString | kDefaultDataLocation = "data"
| Specifies the default storage location for registerFileTranslator, the default value is "data". Search for all occurrences

## Constructor & Destructor Documentation

MFnPlugin | ( |  | ) |

Default class constructor.

The function set is not attached to an MObject.

MFnPlugin | ( | MObject & | object,
|  | const char * | vendor = `"Unknown"`,
|  | const char * | version = `"Unknown"`,
|  | const char * | requiredApiVersion = `"Any"`,
|  | MStatus * | ReturnStatus = `0L`
| ) |  |

Class constructor that initializes the function set to the given MObject.

The MObject should the be one passed as an argument to either the initializePlugin or uninitializePlugin entry points of a Maya plug-in.

Parameters:

  [in] | object | the MObject to attach the function set to
  [in] | vendor | a string identifying the vendor of this plug-in
  [in] | version | a string identifying the version number of this plug-in
  [in] | requiredApiVersion | if the plug-in is known to work with only a specify API version, that version can be specified here. This argument is current not used by the Maya API.
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the function set is not allowed to attach to this MObject or if the MObject does not represent a valid Maya object

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Return the type of this function set.

Returns:
  The constant MFn::kPlugin

Reimplemented from MFnBase.

MString vendor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the vendor string supplied in the MFnPlugin constructor.

Parameters:

  [out] | ReturnStatus | the return status

Returns:
  An MString containing the vendor name

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MString version | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the version string supplied in the MFnPlugin constructor.

Parameters:

  [out] | ReturnStatus | the return status

Returns:
  An MString containing the version string

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MString apiVersion | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the required API version string supplied in the MFnPlugin constructor.

Parameters:

  [out] | ReturnStatus | the return status

- MS::kSuccess if successful
- MS::kObjectDoesNotExist if the function set is not attached to an MObject.

Returns:
  An MString containing the required API version string

MString name | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the name by which Maya knows this plug-in.

Parameters:

  [out] | ReturnStatus | the return status

- MS::kSuccess if successful
- MS::kObjectDoesNotExist if the function set is not attached to an MObject.

Returns:
  An MString containing the plug-in name

MString loadPath | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Determine the path where the plugin was loaded.

Parameters:

  [out] | ReturnStatus | the return status

- MS::kSuccess if successful
- MS::kObjectDoesNotExist if the function set is not attached to an MObject.

Returns:
  An MString containing path name to the location of the plugin.

MStatus setName | ( | const MString & | newName,
|  | bool | makeUnique = `true`
| ) |  |

Search for all occurrences

Set the name by which Maya knows this plug-in.

Parameters:

  [in] | newName | the new name
  [in] | makeUnique | if true and the requested name is already in use, then Maya will create an unused name for this plug-in. If false, and the name is in use, do not change the current name.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure makeUnique was false, and the requested name is already in use
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus setVersion | ( | const MString & | newVersion | ) |

Search for all occurrences

Set the version name for this plug-in.

Parameters:

  [in] | newVersion | the new version

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerCommand | ( | const MString & | commandName,
|  | MCreatorFunction | creatorFunction,
|  | MCreateSyntaxFunction | createSyntaxFunction = `NULL`
| ) |  |

Search for all occurrences

Register a new command with Maya.

Once registered, the command can be invoked from MEL in a manner identical to built-in Maya commands.

Parameters:

  [in] | commandName | the name of the command to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxCommand) that implements the new command.
  [in] | createSyntaxFunction | a pointer to a function that will return a new instance of a syntax object (MSyntax) that implements the syntax of the command.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the command is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

Examples:
  cleanPerFaceAssignmentPluginMain.cpp, latticeNoise.cpp, meshOpMain.cpp, pointOnMeshInfoPlugin.cpp, and splitUVMain.cpp.

MStatus deregisterCommand | ( | const MString & | commandName | ) |

Search for all occurrences

Deregister the user defined command from Maya.

Once deregistered the command can no longer be invoked from MEL.

Parameters:

  [in] | commandName | the name of the command to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the command was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerControlCommand | ( | const MString & | commandName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new control command with Maya.

Once registered, the command can be invoked from MEL in a manner identical to built-in Maya commands.

Parameters:

  [in] | commandName | the name of the control to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class(derived from MPxControlCommand) that implements the new command.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the command is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus deregisterControlCommand | ( | const MString & | commandName | ) |

Search for all occurrences

Deregister the user defined control command from Maya.

Once deregistered the command can no longer be invoked from MEL.

Parameters:

  [in] | commandName | the name of the command to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the command was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerModelEditorCommand | ( | const MString & | commandName,
|  | MCreatorFunction | creatorFunction,
|  | MCreatorFunction | viewCreatorFunction
| ) |  |

Search for all occurrences

Register a new model editor command with Maya.

Once registered, the command can be invoked from MEL in a manner identical to built-in Maya commands.

Parameters:

  [in] | commandName | the name of the command to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxEditorCommand) that implements the new command.
  [in] | viewCreatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPx3dModelView) that implemented the new view associated with this command.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the command is successfully registered
  - MS::kInvalidParameter if the function set is not attached to an MObject

Examples:
  narrowPolyViewerMain.cpp.

MStatus deregisterModelEditorCommand | ( | const MString & | commandName | ) |

Search for all occurrences

Deregister the user defined editor command from Maya.

Once deregistered the command can no longer be invoked from MEL.

Parameters:

  [in] | commandName | the name of the command to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the command was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerConstraintCommand | ( | const MString & | commandName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new constraint command with Maya.

Once registered, the command can be invoked from MEL in a manner identical to built-in Maya commands.

Parameters:

  [in] | commandName | the name of the command to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxConstraintCommand) that implements the new command.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the command is successfully registered
  - MS::kInvalidParameter if the function set is not attached to an MObject

MStatus deregisterConstraintCommand | ( | const MString & | commandName | ) |

Search for all occurrences

Deregister the user defined constraint command from Maya.

Once deregistered the command can no longer be invoked from MEL.

Parameters:

  [in] | commandName | the name of the command to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the command was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerContextCommand | ( | const MString & | commandName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new context command with Maya.

Once registered, the context can be used to create a new tool that can be used in a manner identical to built-in Maya tools.

Parameters:

  [in] | commandName | the name of the context command to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxToolCommand) that implements the new tool.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the command is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

Examples:
  meshReorderPlugin.cpp.

MStatus registerContextCommand | ( | const MString & | commandName,
|  | MCreatorFunction | creatorFunction,
|  | const MString & | toolCmdName,
|  | MCreatorFunction | toolCmdCreator,
|  | MCreateSyntaxFunction | toolCmdSyntax = `NULL`
| ) |  |

Search for all occurrences

Register a new context command and a new tool command with Maya.

This version of registerContextCommand must be used if a tool command (a class derived from MPxToolCommand) is used within the context. The method newToolCommand of MPxContext will return a new instance of the tool command that can be used in the context.

Once registered, the context can be used to create a new tool that can be used in a manner identical to built-in Maya tools. The tool command can also be used as a MEL command.

Parameters:

  [in] | commandName | the name of the context command to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxToolCommand) that implements the new tool.
  [in] | toolCmdName | the name of the tool command to register
  [in] | toolCmdCreator | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxToolCommand) that implements the new command.
  [in] | toolCmdSyntax | a pointer to a function that will return a new instance of a syntax object (MSyntax) that implements the syntax of the command.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the command is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus deregisterContextCommand | ( | const MString & | commandName | ) |

Search for all occurrences

Deregister the given user defined context command from Maya.

Once deregistered the user defined tool can no longer be used.

Parameters:

  [in] | commandName | the name of the context command to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the command was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus deregisterContextCommand | ( | const MString & | commandName,
|  | const MString & | toolCmdName
| ) |  |

Search for all occurrences

Deregister the given user defined context command and tool command from Maya.

Once deregistered the user defined tool can no longer be used and the tool command can no longer be invoked from MEL.

Parameters:

  [in] | commandName | the name of the context command to deregister
  [in] | toolCmdName | the name of the command to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the command was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerNode | ( | const MString & | typeName,
|  | const MTypeId & | typeId,
|  | MCreatorFunction | creatorFunction,
|  | MInitializeFunction | initFunction,
|  | MPxNode::Type | type = `MPxNode::kDependNode`,
|  | const MString * | classification = `NULL`
| ) |  |

Search for all occurrences

Register a new dependency node with Maya.

Once registered, the node can be used from MEL in a manner identical to built-in Maya nodes.

Parameters:

  [in] | typeName | the name of the new type of node
  [in] | typeId | a unique id that identifies this node
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxNode) that implements the new node type
  [in] | initFunction | a pointer to a function that will initialize all the attributes of the new node type
  [in] | type | the type of plugin node to be registered
  [in] | classification | a string that determines how the node will be categorized in various rendering-related UI, such as the Create Render Node and HyperShade windows. See the documentation for the getClassification command for a list of the supported classifications. If no string is supplied then the node will not be considered a rendering node and will not be displayed in those UI.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the node type was successfully registered
  - MS::kFailure the registration failed.
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

Examples:
  blindDataPluginMain.cpp, hlslPluginMain.cpp, latticeNoise.cpp, meshOpMain.cpp, particleAttrNodeMain.cpp, pointOnMeshInfoPlugin.cpp, slopeShader.cpp, and splitUVMain.cpp.

MStatus deregisterNode | ( | const MTypeId & | typeId | ) |

Search for all occurrences

Deregister the given user defined dependency node type Maya.

Once deregistered new instances of the user defined dependency node can no longer be created. Additionally, any existing instances of the node type will be changed to the special type Unknown and will no longer evaluate in the dependency graph although they will be saved correctly if the scene is written.

Parameters:

  [in] | typeId | the unique type id of the node type to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the node type was not owned by this plug-in
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

Examples:
  latticeNoise.cpp.

MStatus registerShape | ( | const MString & | typeName,
|  | const MTypeId & | typeId,
|  | MCreatorFunction | creatorFunction,
|  | MInitializeFunction | initFunction,
|  | MCreatorFunction | uiCreatorFunction,
|  | const MString * | classification = `NULL`
| ) |  |

Search for all occurrences

Registers the given user defined shape node with Maya.

Once registered, the shape can be used from MEL in a manner identical to built-in Maya nodes.

To deregister the shape node use the MFnPlugin::deregisterNode() method.

Parameters:

  [in] | typeName | the name of the new type of user defined shape node
  [in] | typeId | a unique id that identifies this node
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxSurfaceNode) that implements the new shape node type
  [in] | initFunction | a pointer to a function that will initialize all the attributes of the new shape node type
  [in] | uiCreatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MGxSurfaceShapeUI) that is used to implement the drawing and selection functions of the user defined shape.
  [in] | classification | a string that determines how the node will be categorized in various rendering-related UI, such as the Create Render Node and HyperShade windows. See the documentation for the getClassification command for a list of the supported classifications. If no string is supplied then the node will not be considered a rendering node and will not be displayed in those UI.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the node type was successfully registered
  - MS::kFailure the registration failed.
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerTransform | ( | const MString & | typeName,
|  | const MTypeId & | typeId,
|  | MCreatorFunction | creatorFunction,
|  | MInitializeFunction | initFunction,
|  | MCreateXformMatrixFunction | xformCreatorFunction,
|  | const MTypeId & | xformId,
|  | const MString * | classification = `NULL`
| ) |  |

Search for all occurrences

Registers the given user defined transform node with Maya.

Once registered, the transform can be used from MEL in a manner identical to built-in Maya nodes.

To deregister the transform node use the MFnPlugin::deregisterNode() method.

Parameters:

  [in] | typeName | the name of the new type of user defined transform node
  [in] | typeId | a unique id that identifies this node
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxTransform) that implements the new transform node type
  [in] | initFunction | a pointer to a function that will initialize all the attributes of the new transform node type
  [in] | xformCreatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxTransformationMatrix) that is used to implement the matrix functions of the custom transform. For default behavior, use the MPxTransformationMatrix::creator method.
  [in] | xformId | a unique id that identifies this transformation matrix. If MPxTransformationMatrix::creator is used, then MPxTransformationMatrix::baseTransformationMatrixId should be used.
  [in] | classification | a string that determines how the node will be categorized in various rendering-related UI, such as the Create Render Node and HyperShade windows. See the documentation for the getClassification command for a list of the supported classifications. If no string is supplied then the node will not be considered a rendering node and will not be displayed in those UI.

Returns:
  Status code

Status Codes:
  - MS::kSuccess The node type was successfully registered
  - MS::kFailure The registration failed.
  - MS::kObjectDoesNotExist The function set is not attached to an MObject.

Examples:
  rockingTransformCheckMain.cpp, and rockingTransformMain.cpp.

MStatus registerData | ( | const MString & | typeName,
|  | const MTypeId & | typeId,
|  | MCreatorFunction | creatorFunction,
|  | MPxData::Type | type = `MPxData::kData`
| ) |  |

Search for all occurrences

Register a new data type with Maya.

Once registered, the data type can be passed between dependency nodes in a manner identical to built-in Maya data types.

Parameters:

  [in] | typeName | the name of the data type to register
  [in] | typeId | the unique type id of the data type to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxData) that implements the new data type.
  [in] | type | the type of data being registered, see the Type enum in MPxData.h for all available types

/return Status code

Status Codes:
  - MS::kSuccess if the data type is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus deregisterData | ( | const MTypeId & | typeId | ) |

Search for all occurrences

Deregister the given user defined data type from Maya.

It is important to note that this method will always fail if there are any instances of the user-defined data in the scene. If the plug-in were to be allowed to deregister its implementation of the data, it would become impossible to save the scene since the writeASCII and writeBinary methods would no longer be accessible.

Parameters:

  [in] | typeId | the unique type id of the data type to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kFailure the data type is being used by current instances of nodes in the dependency graph
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerDevice | ( | const MString & | deviceName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new input device with Maya.

Once registered, the new input device can be connected to Maya actions using the assignInputDevice command in MEL in a manner identical to built-in Maya devices. In Maya 1.0, only Midi input devices are supported and the creatorFunction must return a pointer to a MPxMidiInputDevice instance. This interface will be generalized in a future release.

Parameters:

  [in] | deviceName | the name of the device to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxMidiInputDevice) that implements the new device.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the device is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus deregisterDevice | ( | const MString & | deviceName | ) |

Search for all occurrences

Deregister the given user defined input device from Maya.

Parameters:

  [in] | deviceName | the name of the input device to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerFileTranslator | ( | const MString & | translatorName,
|  | char * | pixmapName,
|  | MCreatorFunction | creatorFunction,
|  | char * | optionsScriptName = `NULL`,
|  | char * | defaultOptionsString = `NULL`,
|  | bool | requiresFullMel = `false`,
|  | MString | dataStorageLocation = `MFnPlugin::kDefaultDataLocation`
| ) |  |

Search for all occurrences

Register a new file translator with Maya.

It requires a name string containing the "name" by which Maya will refer to this file type, and a pathname to an "icon" file which Maya will use in its file selection dialogs.

Parameters:

  [in] | translatorName | the string by which Maya will refer to this file type
  [in] | pixmapName | the pathname of the icon used in file selection dialogs
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxFileTranslator) that implements the new file type.
  [in] | optionsScriptName | the name of a MEL script that will be used to display the contents of the options dialog during file open and save.
  [in] | defaultOptionsString | the default value of the options string that will be passed to the options script.
  [in] | requiresFullMel | this should be set to true if the reader method in the derived class intends to issue MEL commands via the MGlobal::executeCommand method. Setting this to true will slow down the creation of new objects, but allows MEL commands other than those that are part of the Maya Ascii file format to function correctly. This parameter defaults to false.
  [in] | dataStorageLocation | the default location where this translator will store its data relative to the current project. This defaults to MFnPlugin::kDefaultDataLocation The translator command parameter -defaultFileRule will return this value.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the file translator is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus deregisterFileTranslator | ( | const MString & | translatorName | ) |

Search for all occurrences

Deregister the specified file translator with Maya.

Parameters:

  [in] | translatorName | the name of the translator to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the file translator is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus registerIkSolver | ( | const MString & | ikSolverName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new ik-solver with Maya.

NOTE: this method is obsolete. Instead, register the IK solver as a node as described in the example plug-in simpleSolverNode.cpp.

Parameters:

  [in] | ikSolverName | name of the new IK solver
  [in] | creatorFunction | pointer to a function that will return a pointer to a new instance of the class (derived from MPxIkSolver) that implements the new file type.

Returns:
  Status code

Status Codes:
  - MS::kSuccess The ik-solver was successfully registered
  - MS::kObjectDoesNotExist The function set is not attached to an MObject

MStatus deregisterIkSolver | ( | const MString & | ikSolverName | ) |

Search for all occurrences

Deregister the specified ik-solver with Maya.

NOTE: this method is obsolete. Instead, register the IK solver as a node as described in the example plug-in simpleSolverNode.cpp.

Parameters:

  [in] | ikSolverName | the name of the ik solver to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the ik-solver is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

MStatus registerCacheFormat | ( | const MString & | cacheFormatName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new cache format with Maya.

Parameters:

  [in] | cacheFormatName | Name of the new cache format.
  [in] | creatorFunction | Pointer to a function that will return a pointer to a new instance of the class (derived from MPxCacheFormat) that implements the new file type.

Returns:
  Status code

Status Codes:
  - MS::kSuccess The cache format was successfully registered
  - MS::kObjectDoesNotExist The function set is not attached to an MObject

MStatus deregisterCacheFormat | ( | const MString & | cacheFormatName | ) |

Search for all occurrences

Deregister the specified cache format with Maya.

Parameters:

  [in] | cacheFormatName | the name of the cache format to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the cache format type is successfully deregistered
  - MS::kFailure otherwise

MStatus registerUIStrings | ( | MInitializeFunction | registerMStringResources,
|  | const MString & | pluginStringsProc
| ) |  |

Search for all occurrences

Set the callback and procedure names of routines that register plugin string resources and optionally load localized values for them.

These procedures are called immediately upon plugin load. They are responsible for registering all string resources that can be referred to during the plugin execution. If the string resources are localized, the localized values are also loaded at this time.

Each string resource is given a default value when it is registered. If the plugin is localized, any localized values specified will override the registered default and will be used instead of the default value when the resource value is queried.

The registerMStringResources callback is a function which makes a series of calls to MStringResource::registerString for each MStringResourceId to be registered. Its signature is described by the MInitializeFunction typedef.

The pluginStringsProc is a mel procedure that will be evaluated to register any other strings resources for the plugin, i.e. those used in the plugin's scripts (see the registerPluginString command). It is also responsible for loading the localized resource overrides if they are available (see loadPluginLanguageResources).

See also the following classes: MStringResourceId, MStringResource.

Parameters:

  [in] | registerMStringResources | This callback is used to register MStringResources that are used by the plugin code. The callback signature type is defined by MInitializeFunction.
  [in] | pluginStringsProc | The name of the mel procedure to be run during plugin load to register script-based resources. This script will also make the necessary calls to load localized string values if they exist.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerDragAndDropBehavior | ( | const MString & | behaviorName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Register a new drag and drop behavior with Maya.

Once registered, the new behavior can be used to finish connections between node drag and drops from the hyperGraph/hyperShade to other nodes or Maya UI.

Parameters:

  [in] | behaviorName | the name of the drag and drop behavior to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxDragAndDropBehavior) that implements the new behavior.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the bevavior is successfully registered
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject

Examples:
  slopeShader.cpp.

MStatus deregisterDragAndDropBehavior | ( | const MString & | behaviorName | ) |

Search for all occurrences

Deregister the given drag and drop behavior from Maya.

Parameters:

  [in] | behaviorName | the name of the behavior to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

MStatus registerImageFile | ( | const MString & | imageFormatName,
|  | MCreatorFunction | creatorFunction,
|  | const MStringArray & | imageFileExtensions
| ) |  |

Search for all occurrences

Register a new image file translator with Maya.

Parameters:

  [in] | imageFormatName | the name of the image format to register
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MImageFile) that implements the new file type.
  [in] | imageFileExtensions | this list of file extensions this image file should be associated with.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the image file type is successfully registered
  - MS::kFailure otherwise

MStatus deregisterImageFile | ( | const MString & | imageFormatName | ) |

Search for all occurrences

Deregister the specified image file translator with Maya.

Parameters:

  [in] | imageFormatName | the name of the image format to deregister

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the image file type is successfully deregistered
  - MS::kFailure otherwise

MStatus registerRenderPassImpl | ( | const MString & | passImplId,
|  | MRenderPassDef * | passDef,
|  | MCreatorFunction | creatorFunction,
|  | bool | overload = `false`
| ) |  |

Search for all occurrences

Register a new render pass implementation with Maya and associate with the given render pass definition.

If an implementation with id passImplId has already been registered and creatorFunction is the same as the already registered creator function then the existing implementation will also be used for the current pass (SAME instances). It is an error if the passImplId is already defined and a different creatorFunction is used. If you wish to associate DIFFERENT instances of the same pass implementation with different passes, then use unique passImplIds when registering each.

Parameters:

  [in] | passImplId | a unique name identifying the pass implementation
  [in] | passDef | the render pass definition to associate this implementation with
  [in] | creatorFunction | a pointer to a function that will return a pointer to a new instance of the class (derived from MPxRenderPassImpl) that implements the render pass definiton.
  [in] | overload | Override any existing implementation in the registry

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the render pass implementation is successfully registered
  - MS::kFailure otherwise

MStatus deregisterRenderPassImpl | ( | const MString & | passImplId | ) |

Search for all occurrences

Deregister the specified render pass implementation with Maya.

This will remove the implementation from all passes it is associated with.

Parameters:

  [in] | passImplId | the name identifying the pass implementation to remove

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the render pass implementation is successfully deregistered
  - MS::kFailure otherwise

MStatus registerAttributePatternFactory | ( | const MString & | patternFactoryName,
|  | MCreatorFunction | creatorFunction
| ) |  |

Search for all occurrences

Registers a new attribute pattern factory type with Maya.

Parameters:

  [in] | patternFactoryName | the new attribute pattern factory name.
  [in] | creatorFunction | pointer to function that returns a new instance of an attribute pattern factory.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the attribute pattern factory is successfully registered.
  - MS::kFailure otherwise

MStatus deregisterAttributePatternFactory | ( | const MString & | attributePatternFactoryName | ) |

Search for all occurrences

Deregister the attribute pattern factory type with Maya.

Parameters:

  [in] | attributePatternFactoryName | the attribute pattern factory name.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the attribute pattern factory is successfully deregistered
  - MS::kFailure otherwise

MObject findPlugin | ( | const MString & | pluginName | ) | `[static]`

Search for all occurrences

Returns an MObject corresponding to the named plugin.

If the plugin isn't loaded, the MObject will be kNullObj. This MObject may be used in the same way as the MObject passed to the plugin's initializePlugin() function. Do not hold onto this MObject, if you need it again later, call findPlugin() again.

Parameters:

  [in] | pluginName | the name of the plugin you want a handle for.

Returns:
  - An MObject corresponding to the plugin if the plugin is loaded.
  - MObject::kNullObj if the plugin isn't loaded.

bool isNodeRegistered | ( | const MString & | typeName | ) | `[static]`

Search for all occurrences

Queries if the given typeName has been registered by maya or plugins.

Parameters:

  [in] | typeName | the type name of a depend graph node to query.

Returns:
  true if registered, false otherwise.

MTypeId matrixTypeIdFromXformId | ( | const MTypeId & | xformTypeId,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

The function returns the MTypeId of the matrix when the MTypeId of the corresponding xform is given.

Parameters:

  [in] | xformTypeId | the typeId of the transform.
  [out] | ReturnStatus | Return status.

Returns:
  MTypeId TypeId of the corresponding transformation matrix, if found.

MStringArray addMenuItem | ( | const MString & | menuItemName,
|  | const MString & | parentName,
|  | const MString & | commandName,
|  | const MString & | commandParams,
|  | bool | needOptionBox = `false`,
|  | const MString * | optBoxFunction = `NULL`,
|  | MStatus * | retStatus = `NULL`
| ) |  |

Search for all occurrences

The function adds the menuItem to the specified parent, and associates a command with it.

Additionally, an option box can be created and a MEL function/command can be added to it. The function returns the names of the new menuItem and the optionBox created.

Parameters:

  [in] | menuItemName | This will be used as the label for the menuItem.
  [in] | parentName | Name of the parent to which the new menuItem needs to be attached.
  [in] | commandName | Command to be attached.
  [in] | commandParams | Parameters for the command.
  [in] | needOptionBox | Boolean indicating whether an option box is required. Default value is false.
  [in] | optBoxFunction | MEL Function to be attached to the option box. If the needOptionBox is false, then this argument will have no effect.
  [in] | retStatus | Return status.

Returns:
  MStringArray returns the names of the new menuItems created. In case the method fails, and MStringArray has items in it, removeMenuItem() should be called on it to remove the unused UI references.

MStatus removeMenuItem | ( | MStringArray & | menuItemNames | ) |

Search for all occurrences

The function removes the menuItem and the corresponding option box, if exists, from the UI.

Parameters:

  [in] | menuItemNames | Names of the menuItem which needs to be removed.

Returns:
  Status code

Status Codes:
  - MS::kSuccess Menu item was removed.
  - MS::kFailure An error occurred.

MStatus registerMaterialInfo | ( | const MString & | materialInfoName,
|  | MMaterialInfoFactoryFnPtr | fnPtr
| ) |  |

Search for all occurrences

Registers a new material information type with Maya.

Parameters:

  [in] | materialInfoName | the new material info generator name.
  [in] | fnPtr | pointer to function that return a new instance of material information node.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the material info node is successfully registered.
  - MS::kFailure otherwise

MStatus unregisterMaterialInfo | ( | const MString & | materialInfoName | ) |

Search for all occurrences

Deregister the specified material info type with Maya.

Parameters:

  [in] | materialInfoName | the material info generator name.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the material info node is successfully deregistered
  - MS::kFailure otherwise

MStatus registerBakeEngine | ( | const MString & | bakeEngineGenName,
|  | MBakeEngineCreatorFnPtr | fnPtr
| ) |  |

Search for all occurrences

Registers a new bake engine type with Maya.

Parameters:

  [in] | bakeEngineGenName | the new bake engine generator name.
  [in] | fnPtr | pointer to function that return a new instance of bake engine generator node.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the bake engine generator node is successfully registered.
  - MS::kFailure otherwise

MStatus unregisterBakeEngine | ( | const MString & | bakeEngineGenName | ) |

Search for all occurrences

Deregister the bake engine type with Maya.

Parameters:

  [in] | bakeEngineGenName | the bake engine generator name.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if the bake engine generator node is successfully deregistered
  - MS::kFailure otherwise

MStatus registerTransform | ( | const MString & | typeName,
|  | const MTypeId & | typeId,
|  | MCreatorFunction | creatorFunction,
|  | MInitializeFunction | initFunction,
|  | MCreatorFunction | xformCreatorFunction,
|  | const MTypeId & | xformId,
|  | const MString * | classification = `NULL`
| ) |  |

Search for all occurrences

Obsolete.

This method is obsolete.

Deprecated:
  Use the other version of registerTransform instead.

Parameters:

  [in] | typeName |
  [in] | typeId |
  [in] | creatorFunction |
  [in] | initFunction |
  [in] | xformCreatorFunction |
  [in] | xformId |
  [in] | classification |

Returns:
  Status code

MStatus registerUI | ( | const MString & | creationProc,
|  | const MString & | deletionProc,
|  | const MString & | creationBatchProc = `""`,
|  | const MString & | deletionBatchProc = `""`
| ) |  |

Search for all occurrences

NO SCRIPT SUPPORT.

Sets the names of the mel procedures to be evaled to create and destroy any UI associated with the plugin.

You can use MEL procedure names as arguments to this method as long as the procedure is located in a file named procedure.mel. This works because, as described in the MEL documentation, when MEL is given a undefined procedure, it searchs MAYA_SCRIPT_PATH looking for a file with the name procedure.mel. If it finds such a file it is sourced and if the procedure was defined by the file, it is then executed.

Example: The procedure lassoToolCreateUI will be run when the plugin is loaded, the procedure lassoToolDeleteUI when the plugin is unloaded. This works as long as the MEL procedure lassoToolCreateUI is defined in a file called lassoToolCreateUI.mel and the procedure lassoToolDeleteUI is defined in a file called lassoToolDeleteUI.mel.

    MStatus initializePlugin( MObject obj )
    {
        MStatus status;

        MFnPlugin plugin( obj, "Autodesk - Example", "1.0", "Any");
        status = plugin.registerContextCommand( "lassoToolContext",
                                                lassoContextCmd::creator );

        if (!status) {
            status.perror("registerContextCommand");
            return status;
        }

        // set the mel procs to be run when the plugin is loaded / unloaded
        status = plugin.registerUI("lassoToolCreateUI", "lassoToolDeleteUI");
        if (!status) {
            status.perror("registerUIScripts");
            return status;
        }

        return status;
    }

Parameters:

  [in] | creationProc | The name of the procedure to be run when the plug in is loaded
  [in] | deletionProc | The name of the procedure to be run when the plug in is unloaded
  [in] | creationBatchProc | The name of the procedure to be run when the plug in is loaded in batch mode. The procedure should not contain UI related code.
  [in] | deletionBatchProc | The name of the procedure to be run when the plug in is unloaded in batch mode. The procedure should not contain UI related code.

Returns:
  Status code

Status Codes:
  - MS::kSuccess if successful
  - MS::kObjectDoesNotExist if the function set is not attached to an MObject.

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  Name of this class.

Reimplemented from MFnBase.

MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin
MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin MFnPlugin